#!/usr/bin/perl

use strict;
use warnings;
use Encode qw/decode/;
use Encode qw/encode/;
use utf8;

use XML::XPath;
use XML::XPath::XMLParser;

my $xpath = XML::XPath->new( filename => shift @ARGV );
my $id = shift @ARGV;
my $result = shift @ARGV;
my @result_all = ();

open LIST, "$id" or die;
my %data_set = ();
while (<LIST>) {
	s/(\r\n|\n|\r)$//;
	my $line = decode('UTF-8', $_);
	my($triple, $entity, $id) = split /\t/, $line;
	my @result = ($triple, $entity);
	push @{$data_set{$id}}, \@result;
}
close LIST;

open RESULT, ">$result" or die;
our $result_fh = *RESULT;
OUTER: foreach my $id (sort keys %data_set) {
	my @result = ($id);
	print RESULT encode('UTF-8', "\n$id\n");

	# STEP 0
	# attribute_slimのチェック
	my $xpath_exp0 = '/OE_FILE/W_CONCEPTS/CONCEPT/LABEL[text()=\'' . $id . '\']/../DEF';
	my @value0 = &getNodeValue($xpath_exp0, 0);
	my $value0_count = @value0;

	if ( $value0_count == 1 ) {
		if ( $value0[0] =~ /\[inSubset\]:attribute_slim/ ) {
			print RESULT encode('UTF-8', "attribute_slimのため、対象外とする。\n");
			next OUTER;
		}
	}

	# STEP 1
	# PATO IDからVALUEを取得
	my $xpath_exp1 = '/OE_FILE/W_CONCEPTS/CONCEPT/LABEL[text()=\'' . $id . '\']/../SLOTS/SLOT[@role=\'referring to\']/@class_constraint';
	my @value1 = &getNodeValue($xpath_exp1, 1);
	my $value1_count = @value1;
	
	# class_constraint属性値が1個
	if ( $value1_count == 1 ) {
	
		# class_constraint属性値が真
		if ( $value1[0] ) {
			push @result, $value1[0];
			print RESULT encode('UTF-8', "$value1[0]\n");

		# class_constraint属性値が空
		} else {
			print RESULT encode('UTF-8', "role属性値がreferring toであるSLOT要素のclass_constraint属性値が空になっている。親の概念を検索...\n");
	
			my $fromParent1 = &getParentAndCheck($id);
			if ( $fromParent1 ) {
				push @result, $fromParent1;
				print RESULT encode('UTF-8', "is_a:$fromParent1\n");
			} else {
				next OUTER;
			}
		}
	
	# class_constraint属性値が0個
	} elsif ( $value1_count == 0 ) {
		my $xpath_exp1d = '/OE_FILE/W_CONCEPTS/CONCEPT/LABEL[text()=\'' . $id . '\']';
		my @value1d = &getNodeValue($xpath_exp1d, 0);
		my $value1d_count = @value1d;
	
		if ( $value1d_count == 1 ) {
			print RESULT encode('UTF-8', "${id}の概念は見つかったが、role属性値がreferring toかつclass_constraint属性値を持つSLOT要素が見つからない。親の概念を検索...\n");
	
			my $fromParent2 = &getParentAndCheck($id);
			if ( $fromParent2 ) {
				push @result, $fromParent2;
				print RESULT encode('UTF-8', "is_a:$fromParent2\n");
			} else {
				next OUTER;
			}
	
		} elsif ( $value1d_count == 0 ) {
			print RESULT encode('UTF-8', "${id}の概念が見つからない。\n");
			next OUTER;
		} else {
			print RESULT encode('UTF-8', "${id}の概念が${value1d_count}個見つかった。\n");
			next OUTER;
		}
	
	# class_constraint属性値が2個以上
	} else {
		print RESULT encode('UTF-8', "role属性値がreferring toであるSLOT要素のclass_constraint属性値が${value1_count}個見つかった。\n");
		my $i = 1;
		foreach my $value ( @value1 ) {
			print RESULT encode('UTF-8', "$i $value\n");
			++$i;
		}
		next OUTER;
	}
	
	# STEP 2
	# STEP 1で取得したVALUEから、VALUEの値を持つ概念名を取得
	my $xpath_exp2 = '/OE_FILE/W_CONCEPTS/CONCEPT/SLOTS/SLOT[@rh_name=\'' . $result[1] . '\']/@class_constraint';
	my @result_two = &step_two($xpath_exp2, @result);
	if ($result_two[0] == 0) {
		print RESULT encode('UTF-8', "$result_two[1] (1)\n");
		next OUTER;
	} elsif ($result_two[0] == 1) {
		push @result, $result_two[1];
		print RESULT encode('UTF-8', "$result_two[1]\n");
	} elsif ($result_two[0] == 2) {
		my $xpath_exp2b = '/OE_FILE/OTHER_ONTS/OTHER_ONT/W_CONCEPTS/CONCEPT/SLOTS/SLOT[@rh_name=\'' . $result[1] . '\']/@class_constraint';
		my @result_two_b = &step_two($xpath_exp2b, @result);
		if ($result_two_b[0] == 0) {
			print RESULT encode('UTF-8', "$result_two_b[1] (2)\n");
			next OUTER;
		} elsif ($result_two_b[0] == 1) {
			push @result, $result_two_b[1];
			print RESULT encode('UTF-8', "$result_two_b[1]\n");
		} elsif ($result_two_b[0] == 2) {
			push @result, $result[1];
			print RESULT encode('UTF-8', "rh_name属性値が$result[1]であるSLOT要素のclass_constraint属性値が見つからない。LABELが$result[1]である概念を検索...\n");
		}
	} else {
		print RESULT encode('UTF-8', "ERROR STEP2\n");
		next OUTER;
	}

	# STEP 3
	my $step_three_count = 0;
	INNER: while ( $step_three_count < 4 ) {
		if ( $step_three_count == 3 ) {
			print RESULT encode('UTF-8', "親概念探索の繰り返し回数を超過。\n");
			next OUTER;
		}

		# STEP 2で取得した概念名からATTRIBUTEを取得
		my $xpath_exp3_forward = '/OE_FILE/OTHER_ONTS/OTHER_ONT/W_CONCEPTS/CONCEPT/LABEL[text()=\'';
		my @result_three = &step_three($xpath_exp3_forward, @result);
		if ($result_three[0] == 0) {
			print RESULT encode('UTF-8', "$result_three[1] (1)\n");
			next OUTER;
		} elsif ($result_three[0] == 1) {
			push @result, $result_three[1];
			print RESULT encode('UTF-8', "$result_three[1]\n");
			last INNER;
		} elsif ($result_three[0] == 2) {
			my $xpath_exp3b_forward = '/OE_FILE/W_CONCEPTS/CONCEPT/LABEL[text()=\'';
			my @result_three_b = &step_three($xpath_exp3b_forward, @result);
			if ($result_three_b[0] == 0) {
				print RESULT encode('UTF-8', "$result_three_b[1] (2)\n");
				next OUTER;
			} elsif ($result_three_b[0] == 1) {
				push @result, $result_three_b[1];
				print RESULT encode('UTF-8', "$result_three_b[1]\n");
				last INNER;
			} elsif ($result_three_b[0] == 2) {
				print RESULT encode('UTF-8', "LABELが$result[2]である概念が見つからない。\n");
				next OUTER;
			} elsif ($result_three_b[0] == 3) {
				# ISA要素を辿って親概念を検索する。
				my $parent_concept = &getParentConcept($result[2]);
				if ( $parent_concept ) {
					$result[2] = $parent_concept;
					++$step_three_count;
				} else {
					next OUTER;
				}
			}
		} elsif ( $result_three[0] == 3 ) {
			# ISA要素を辿って親概念を検索する。
			my $parent_concept = &getParentConcept($result[2]);
			if ( $parent_concept ) {
				$result[2] = $parent_concept;
				++$step_three_count;
			} else {
				next OUTER;
			}
		} else {
			print RESULT encode('UTF-8', "ERROR STEP3\n");
			next OUTER;
		}
	}

	push @result_all, \@result;
}
close RESULT;

# 出力ファイル処理
my $outfile = 'EAV_conversion.ont';
open OUT, ">$outfile" or die;
my $time = time;
$time = $time * 1000;
my $pos_x1_base = 100;
my $pos_y1_base = 100;
my $pos_x2_base = 500;
my $pos_y2_base = 500;

my $xml_head = <<XML_HEAD;
<?xml version="1.0" encoding="UTF-8"?>
<OE_FILE filename="EAV_conversion.ont" ont_id="" author="masuya" ontname="EAV conversion" update="$time" project="GeneOnto" comment="">
<FILENAME_ONT>EAV conversion.ont</FILENAME_ONT>
<W_CONCEPTS hasAny="false">
    <CANVAS_SIZE w="2276" h="2198" />
    <CONCEPT id="" >
        <LABEL>E_A_V_1</LABEL>
        <SUB_LABELS></SUB_LABELS>
        <POS x="$pos_x1_base" y="$pos_y1_base"/>
        <SUB_TREE>open</SUB_TREE>
        <SLOTS>
            <SLOT id="" type="OR" label="slot2" kind="p/o" num="1" role="form" class_constraint="triple_1" rh_name="" value="" >
                <SUB_LABELS></SUB_LABELS>
                <PARENT_SLOT slot="quality representation_3\$slot3"/>
                <SLOTS>
                    <SLOT id="" type="OR" label="slot3:triple:slot" kind="p/o" num="1" role="object" class_constraint="*entity" rh_name="" value="" >
                        <SUB_LABELS></SUB_LABELS>
                        <PARENT_SLOT slot="triple_1\$slot"/>
                        <SUB_L label="" def="" role_name="" class_const="*entity" rh_name ="" value ="" />
                    </SLOT>
                    <SLOT id="" type="R2-2" label="slot" kind="p/o" num="1" role="attribute" class_constraint="#quality_1" rh_name="" value="" >
                        <SUB_LABELS></SUB_LABELS>
                        <PARENT_SLOT slot="triple_1\$slot2"/>
                        <SUB_L label="slot" def="" role_name="attribute" class_const="#quality_1" rh_name ="" value ="" />
                    </SLOT>
                    <SLOT id="" type="R2-2" label="slot2" kind="p/o" num="1" role="value" class_constraint="represented quantity | qualitative quantity | number | categorical | #entity" rh_name="value" value="" >
                        <SUB_LABELS></SUB_LABELS>
                        <PARENT_SLOT slot="triple_1\$slot3"/>
                        <SUB_L label="slot2" def="" role_name="value" class_const="represented quantity | qualitative quantity | number | categorical | #entity" rh_name ="value" value ="" />
                    </SLOT>
                </SLOTS>
                <SUB_L label="slot2" def="" role_name="表現形態" class_const="三つ組み" rh_name ="" value ="" />
            </SLOT>
        </SLOTS>
        <RELATIONS></RELATIONS>
        <SUB_L label="" def="" role_name="" class_const="" rh_name ="" value ="" />
    </CONCEPT>
XML_HEAD

print OUT encode('UTF-8', "$xml_head");

my $i = 0;
#my %triple_checker1 = ();
foreach my $result (@result_all) {
	my $id = ${$result}[0];
	my $attribute = ${$result}[3];
	my $value = ${$result}[1];
	foreach my $data_set (@{$data_set{$id}}) {
		my $triple = ${$data_set}[0];
		my $entity = ${$data_set}[1];

#++$triple_checker1{$triple};
#if ($triple_checker1{$triple} > 1) {
#	print encode('UTF-8', "$triple\n");
#	next;
#}

		my $pos_x1 = $pos_x1_base + $i;
		my $pos_y1 = $pos_y2_base + $i;
	
		my $xml_EAV = <<XML_EAV;
    <CONCEPT id="" >
        <LABEL>EAV_${triple}_1</LABEL>
        <SUB_LABELS></SUB_LABELS>
        <POS x="$pos_x1" y="$pos_y1"/>
        <SLOTS>
            <SLOT id="" type="OR" label="slot2" kind="p/o" num="1" role="form" class_constraint="triple_${triple}" rh_name="" value="" >
                <SUB_LABELS></SUB_LABELS>
                <PARENT_SLOT slot="E_A_V_1\$slot2"/>
                <SUB_L label="" def="" role_name="" class_const="triple_${triple}" rh_name ="" value ="" />
            </SLOT>
        </SLOTS>
        <RELATIONS></RELATIONS>
    </CONCEPT>
XML_EAV

		print OUT encode('UTF-8', "$xml_EAV");
		$i = $i + 50;
	}
}

my $xml_middle = <<XML_MID;
    <CONCEPT id="" >
        <LABEL>triple_1</LABEL>
        <SUB_LABELS></SUB_LABELS>
        <POS x="$pos_x2_base" y="$pos_y1_base"/>
        <SUB_TREE>open</SUB_TREE>
        <SLOTS>
            <SLOT id="" type="NW" label="slot" kind="p/o" num="1" role="first" class_constraint="Any" rh_name="" value="" >
                <SUB_LABELS></SUB_LABELS>
                <SUB_L label="slot" def="" role_name="first" class_const="Any" rh_name ="" value ="" />
            </SLOT>
            <SLOT id="" type="NW" label="slot2" kind="p/o" num="1" role="second" class_constraint="Any" rh_name="" value="" >
                <SUB_LABELS></SUB_LABELS>
                <SUB_L label="slot2" def="" role_name="second" class_const="Any" rh_name ="" value ="" />
            </SLOT>
            <SLOT id="" type="NW" label="slot3" kind="p/o" num="1" role="third" class_constraint="Any" rh_name="" value="" >
                <SUB_LABELS></SUB_LABELS>
                <SUB_L label="slot3" def="" role_name="third" class_const="Any" rh_name ="" value ="" />
            </SLOT>
        </SLOTS>
        <RELATIONS></RELATIONS>
        <SUB_L label="三つ組み" def="" role_name="" class_const="" rh_name ="" value ="" />
    </CONCEPT>
XML_MID

print OUT encode('UTF-8', "$xml_middle");

my $j = 0;
#my %triple_checker2 = ();
foreach my $result (@result_all) {
	my $id = ${$result}[0];
	my $attribute = ${$result}[3];
	my $value = ${$result}[1];
	foreach my $data_set (@{$data_set{$id}}) {
		my $triple = ${$data_set}[0];
		my $entity = ${$data_set}[1];

#++$triple_checker2{$triple};
#next if $triple_checker2{$triple} > 1;

		my $pos_x1 = $pos_x2_base + $j;
		my $pos_y1 = $pos_y2_base + $j;
	
		my $xml_TRIPLE_EAV = <<XML_TRIPLE_EAV;
    <CONCEPT id="" >
        <LABEL>triple_${triple}</LABEL>
        <SUB_LABELS></SUB_LABELS>
        <POS x="$pos_x1" y="$pos_y1"/>
        <SLOTS>
            <SLOT id="" type="OR" label="slot" kind="p/o" num="1" role="first" class_constraint="$entity" rh_name="" value="" >
                <SUB_LABELS></SUB_LABELS>
                <PARENT_SLOT slot="triple_1\$slot"/>
                <SUB_L label="" def="" role_name="" class_const="$entity" rh_name ="" value ="" />
            </SLOT>
            <SLOT id="" type="OR" label="slot2" kind="p/o" num="1" role="second" class_constraint="$attribute" rh_name="" value="" >
                <SUB_LABELS></SUB_LABELS>
                <PARENT_SLOT slot="triple_1\$slot2"/>
                <SUB_L label="" def="" role_name="" class_const="$attribute" rh_name ="" value ="" />
            </SLOT>
            <SLOT id="" type="OR" label="slot3" kind="p/o" num="1" role="third" class_constraint="$value" rh_name="" value="" >
                <SUB_LABELS></SUB_LABELS>
                <PARENT_SLOT slot="triple_1\$slot3"/>
                <SUB_L label="" def="" role_name="" class_const="$value" rh_name ="" value ="" />
            </SLOT>
        </SLOTS>
        <RELATIONS></RELATIONS>
    </CONCEPT>
XML_TRIPLE_EAV

		print OUT encode('UTF-8', "$xml_TRIPLE_EAV");
		$j = $j + 50;
	}
}

#my %triple_checker3 = ();
foreach my $result (@result_all) {
	my $id = ${$result}[0];
	my $attribute = ${$result}[3];
	my $value = ${$result}[1];
	foreach my $data_set (@{$data_set{$id}}) {
		my $triple = ${$data_set}[0];
		my $entity = ${$data_set}[1];

#++$triple_checker3{$triple};
#next if $triple_checker3{$triple} > 1;

		my $isa1 = <<ISA1;
    <ISA id="" parent="E_A_V_1" child="EAV_${triple}_1" />
ISA1

		print OUT encode('UTF-8', "$isa1");
	}
}

#my %triple_checker4 = ();
foreach my $result (@result_all) {
	my $id = ${$result}[0];
	my $attribute = ${$result}[3];
	my $value = ${$result}[1];
	foreach my $data_set (@{$data_set{$id}}) {
		my $triple = ${$data_set}[0];
		my $entity = ${$data_set}[1];

#++$triple_checker4{$triple};
#next if $triple_checker4{$triple} > 1;

		my $isa2 = <<ISA2;
    <ISA id="" parent="triple_1" child="triple_${triple}" />
ISA2

		print OUT encode('UTF-8', "$isa2");
	}
}

my $xml_tail = <<XML_TAIL;
</W_CONCEPTS>
<R_CONCEPTS>
    <CANVAS_SIZE w="2276" h="2232" />
</R_CONCEPTS>
<OTHER_ONTS>
    <W_DEPENDENCY></W_DEPENDENCY>
    <R_DEPENDENCY></R_DEPENDENCY>
</OTHER_ONTS>
<PRINTER>
    <PAGE_SETTINGS header="true" footer="true" cropmarks="true" scale="100" />
    <PAGE_FORMAT w="595.0" h="842.0" iw="559.0" ih="783.0" ix="18.0" iy="18.0" />
    <PRINTER_SETTINGS orientation="1" printername="DLP2330_108" />
</PRINTER>
</OE_FILE>
XML_TAIL

print OUT encode('UTF-8', "$xml_tail");
close OUT;

sub getNodeValue {
	my $xpath_exp = $_[0];
	my $flag = $_[1];
	my $nodeset = $xpath->find( $xpath_exp );
	my @value = ();
	foreach my $node ( $nodeset->get_nodelist ) {
		my $node_text = XML::XPath::XMLParser::as_string( $node );
		$node_text =~ s/^.*"(.*)".*$/$1/ if $flag;
		push @value, $node_text;
	}
	return @value;
}


sub getParentAndCheck {
	# is_aリンクを１段上がったCONCEPT要素のrole attributeの属性値が"referring to"である孫要素SLOT要素を検索する。
	my $id = shift @_;

	my $xpath_exp1b = '/OE_FILE/W_CONCEPTS/ISA[@child=\'' . $id . '\']/@parent';
	my @value1b = &getNodeValue($xpath_exp1b, 1);
	my $value1b_count = @value1b;

	# parent属性値が1個
	if ( $value1b_count == 1 ) {

		# parent属性値が真
		if ( $value1b[0] ) {
			print $result_fh encode('UTF-8', "親概念$value1b[0]を${id}の代用とする。\n");

			my $xpath_exp1c = '/OE_FILE/W_CONCEPTS/CONCEPT/LABEL[text()=\'' . $value1b[0] . '\']/parent::*/SLOTS/SLOT[@role=\'referring to\']/@class_constraint';
			my @value1c = &getNodeValue($xpath_exp1c, 1);
			my $value1c_count = @value1c;

			# class_constraint属性値が1個
			if ( $value1c_count == 1 ) {

				# class_constraint属性値が真
				if ( $value1c[0] ) {
					return $value1c[0];

				# class_constraint属性値が空
				} else {
					print $result_fh encode('UTF-8', "親概念が1個見つかったが、role属性値がreferring toであるSLOT要素のclass_constraint属性値が空になっている。\n");
					return '';
				}

			# class_constraint値が0個
			} elsif ( $value1c_count == 0 ) {
				print $result_fh encode('UTF-8', "親概念が1個見つかったが、role属性値がreferring toかつclass_constraint属性値を持つSLOT要素が作成されていない。\n");
				return '';

			# class_constraint値が2個以上
			} else {
				print $result_fh encode('UTF-8', "1個の親概念からrole属性値がreferring toであるSLOT要素のclass_constraint属性値が${value1c_count}個得られた。\n");
				my $i = 1;
				foreach my $value ( @value1c ) {
					print $result_fh encode('UTF-8', "$i $value\n");
					++$i;
				}
				return '';
			}

		# parent属性値が空
		} else {
			print $result_fh encode('UTF-8', "${id}の親概念が見つからない(1)。\n");
			return '';
		}

	# parent属性値が0個
	} elsif ( $value1b_count== 0 ) {
		print $result_fh encode('UTF-8', "${id}の親概念が見つからない(2)。\n");
		return '';

	# parent属性値が2個以上
	} else {
		print $result_fh encode('UTF-8', "${id}の親概念が${value1b_count}個見つかった：@value1b\n");
		return '';
	}
}

sub getParentConcept {
	# child属性値が$idであるISA要素のparent属性値を取得する。
	my $id = shift @_;

	my $xpath_exp1b = '/OE_FILE/W_CONCEPTS/ISA[@child=\'' . $id . '\']/@parent';
	my @value1b = &getNodeValue($xpath_exp1b, 1);
	my $value1b_count = @value1b;

	# parent属性値が1個
	if ( $value1b_count == 1 ) {

		# parent属性値が真
		if ( $value1b[0] ) {
			print $result_fh encode('UTF-8', "親概念$value1b[0]を${id}の代用とする。\n");
			return $value1b[0];

		# parent属性値が空
		} else {
			print $result_fh encode('UTF-8', "${id}の親概念が見つからない(parent属性値が空)。\n");
			return '';
		}

	# parent属性値が0個
	} elsif ( $value1b_count== 0 ) {
		print $result_fh encode('UTF-8', "${id}の親概念が見つからない(2)。\n");
		return '';

	# parent属性値が2個以上
	} else {
		print $result_fh encode('UTF-8', "${id}の親概念が${value1b_count}個見つかった：@value1b\n");
		return '';
	}
}

sub step_three {
	my $xpath_exp3_forward = shift @_;
	my @result = @_;
	my $xpath_exp3 = $xpath_exp3_forward . $result[2] . '\']/parent::*/SLOTS/SLOT[@role=\'value of\']/@class_constraint';
	my @value3 = &getNodeValue($xpath_exp3, 1);
	my $value3_count = @value3;
	
	# class_constraint属性値が1個
	if ( $value3_count == 1 ) {
	
		# class_constraint属性値が真
		if ( $value3[0] ) {
			if ( $value3[0] =~ /^#/ ) {
				return(1, $value3[0]);
			} else {
				return(0, "$value3[0]: 属性値の頭に#が付いていない。");
			}
	
		# class_constraint属性値が空
		} else {
			# ISA要素を辿って親概念を探す。
			return(3, "$result[2]概念においてrole属性値がvalue ofであるSLOT要素のclass_constraint属性値が空になっている。親概念を検索...");
		}
	
	# class_constraint属性値が0個
	} elsif ( $value3_count == 0 ) {
	
		# 概念の有無をチェック
#		my $xpath_exp3d = '/OE_FILE/OTHER_ONTS/OTHER_ONT/W_CONCEPTS/CONCEPT/LABEL[text()=\'' . $result[2] . '\']';
		my $xpath_exp3d = $xpath_exp3_forward . $result[2] . '\']';
		my @value3d = &getNodeValue($xpath_exp3d, 0);
		my $value3d_count = @value3d;
	
		# 概念が1個
		if ( $value3d_count == 1 ) {
			# ISA要素を辿って親概念を探す。
			return(3, "LABELが$result[2]である概念が1個見つかったが、role属性値がvalue ofであるSLOT要素のclass_constraint属性値が見つからない。親概念を検索...");
	
		# 概念が0個
		} elsif ( $value3d_count == 0 ) {
			return(2);
	
		# 概念が2個以上
		} else {
			return(0, "LABELが$result[2]である概念が${value3d_count}個見つかったが、role属性値がvalue ofであるSLOT要素のclass_constraint属性値が見つからない。");
		}
	
	# class_constraint属性値が2個以上
	} else {
	
		# 概念をチェック
		&checkConcept($result[2]);
		my $xpath_exp3e = '/OE_FILE/OTHER_ONTS/OTHER_ONT/W_CONCEPTS/CONCEPT/LABEL[text()=\'' . $result[2] . '\']';
		my @value3e = &getNodeValue($xpath_exp3e, 0);
		my $value3e_count = @value3e;
	
		# 概念が1個
		if ( $value3e_count == 1 ) {
			my $string = "LABELが$result[2]である1個の概念からrole属性値がvalue ofであるSLOT要素のclass_constraint属性値が${value3_count}個見つかった。\n";
			my $i = 1;
			foreach my $value ( @value3 ) {
				$string .= "$i $value\n";
				++$i;
			}
			$string =~ s/\n$//;
			return (0, $string);
	
		# 概念が2個以上
		} else {
			my $string = "LABELが$result[2]である概念が${value3e_count}個見つかり、role属性値がvalue ofであるSLOT要素のclass_constraint属性値が${value3_count}個見つかった。\n";
			my $i = 1;
			foreach my $value ( @value3 ) {
				$string .= "$i $value\n";
				++$i;
			}
			$string =~ s/\n$//;
			return(0, $string);
		}
	}
}

sub step_two {
	my $xpath_exp2 = shift @_;
	my @result = @_;
	my @value2 = &getNodeValue($xpath_exp2, 1);
	my $value2_count = @value2;
	
	# class_constraint属性値が1個
	if ( $value2_count == 1 ) {
	
		# class_constraint属性値が真
		if ( $value2[0] ) {
			return(1, $value2[0]);
	
		# class_constraint属性値が空
		} else {
			return(0, "rh_name属性値が$result[1]であるSLOT要素のclass_constraint属性値が空になっている。\n");
		}
	
	# class_constraint属性値が0個
	} elsif ( $value2_count == 0 ) {
		return(2);
	
	# class_constraint属性値が2個以上
	} else {
		my $string = "rh_name属性値が$result[1]であるSLOT要素のclass_constraint属性値が${value2_count}個見つかった。\n";
		my $i = 1;
		foreach my $value ( @value2 ) {
			$string .= "$i $value\n";
			++$i;
		}
		return(0, $string);
	}
}